<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="父级id" prop="homeParentId">
        <el-input
          v-model="queryParams.homeParentId"
          placeholder="请输入父级id"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="链接地址" prop="link">
        <el-input
          v-model="queryParams.link"
          placeholder="请输入链接地址"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="首页分组类型" prop="homeGroupType">
        <el-select v-model="queryParams.homeGroupType" placeholder="请选择首页分组类型" clearable size="small">
          <el-option
            v-for="dict in dict.type.home_grou_type"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
	    <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['app:apphomedata:add']"
        >新增</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="apphomedataList"
      row-key="homeContentId"
      default-expand-all
      :tree-props="{children: 'children', hasChildren: 'hasChildren'}"
    >
      <el-table-column label="父级id" prop="homeParentId" />
      <el-table-column label="文本内容" align="center" prop="text" />
      <el-table-column label="链接地址" align="center" prop="link" />
      <el-table-column label="图片路径" align="center" prop="imgPath" />
      <el-table-column label="首页分组类型" align="center" prop="homeGroupType">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.home_grou_type" :value="scope.row.homeGroupType"/>
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['app:apphomedata:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-plus"
            @click="handleAdd(scope.row)"
            v-hasPermi="['app:apphomedata:add']"
          >新增</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['app:apphomedata:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!-- 添加或修改app首页数据对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="父级id" prop="homeParentId">
          <treeselect v-model="form.homeParentId" :options="apphomedataOptions" :normalizer="normalizer" placeholder="请选择父级id" />
        </el-form-item>
        <el-form-item label="文本内容">
          <editor v-model="form.text" :min-height="192"/>
        </el-form-item>
        <el-form-item label="链接地址" prop="link">
          <el-input v-model="form.link" placeholder="请输入链接地址" />
        </el-form-item>
        <el-form-item label="图片路径">
          <imageUpload v-model="form.imgPath"/>
        </el-form-item>
        <el-form-item label="首页分组类型" prop="homeGroupType">
          <el-select v-model="form.homeGroupType" placeholder="请选择首页分组类型">
            <el-option
              v-for="dict in dict.type.home_grou_type"
              :key="dict.value"
              :label="dict.label"
              :value="parseInt(dict.value)"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listApphomedata, getApphomedata, delApphomedata, addApphomedata, updateApphomedata, exportApphomedata } from "@/api/app/apphomedata";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";

export default {
  name: "Apphomedata",
  dicts: ['home_grou_type'],
  components: {
    Treeselect
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 显示搜索条件
      showSearch: true,
      // app首页数据表格数据
      apphomedataList: [],
      // app首页数据树选项
      apphomedataOptions: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        homeParentId: null,
        text: null,
        link: null,
        imgPath: null,
        homeGroupType: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        homeParentId: [
          { required: true, message: "父级id不能为空", trigger: "blur" }
        ],
        homeGroupType: [
          { required: true, message: "首页分组类型不能为空", trigger: "change" }
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询app首页数据列表 */
    getList() {
      this.loading = true;
      listApphomedata(this.queryParams).then(response => {
        this.apphomedataList = this.handleTree(response.data, "homeContentId", "homeParentId");
        this.loading = false;
      });
    },
    /** 转换app首页数据数据结构 */
    normalizer(node) {
      if (node.children && !node.children.length) {
        delete node.children;
      }
      return {
        id: node.homeContentId,
        label: node.text,
        children: node.children
      };
    },
	/** 查询app首页数据下拉树结构 */
    getTreeselect() {
      listApphomedata().then(response => {
        this.apphomedataOptions = [];
        const data = { homeContentId: 0, text: '顶级节点', children: [] };
        data.children = this.handleTree(response.data, "homeContentId", "homeParentId");
        this.apphomedataOptions.push(data);
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        homeContentId: null,
        homeParentId: null,
        text: null,
        link: null,
        imgPath: null,
        homeGroupType: null,
        isDelete: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        remark: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd(row) {
      this.reset();
      this.getTreeselect();
      if (row != null && row.homeContentId) {
        this.form.homeParentId = row.homeContentId;
      } else {
        this.form.homeParentId = 0;
      }
      this.open = true;
      this.title = "添加app首页数据";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.getTreeselect();
      if (row != null) {
        this.form.homeParentId = row.homeContentId;
      }
      getApphomedata(row.homeContentId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改app首页数据";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.homeContentId != null) {
            updateApphomedata(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addApphomedata(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      this.$modal.confirm('是否确认删除app首页数据编号为"' + row.homeContentId + '"的数据项？').then(function() {
        return delApphomedata(row.homeContentId);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    }
  }
};
</script>
